import React, { useEffect, useState } from 'react';
import { Search as SearchIcon } from '@mui/icons-material';
import { styled, alpha } from '@mui/material/styles';
import { InputBase } from '@mui/material';
var timeout = null;
var Search = styled('div')(function (_ref) {
  var _ref2;

  var theme = _ref.theme,
      isOpen = _ref.isOpen;
  return _ref2 = {
    position: 'relative',
    borderRadius: theme.shape.borderRadius,
    backgroundColor: isOpen ? alpha(theme.palette.common.white, 0.15) : undefined,
    '&:hover': {
      backgroundColor: alpha(theme.palette.common.white, 0.25)
    },
    marginLeft: 0,
    width: '100%'
  }, _ref2[theme.breakpoints.up('sm')] = {
    marginLeft: theme.spacing(1),
    width: 'auto'
  }, _ref2;
});
var SearchIconWrapper = styled('div')(function (_ref3) {
  var theme = _ref3.theme;
  return {
    padding: theme.spacing(0, 2),
    height: '100%',
    position: 'absolute',
    pointerEvents: 'none',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center'
  };
});
var StyledInputBase = styled(InputBase)(function (_ref4) {
  var _MuiInputBaseInpu;

  var theme = _ref4.theme,
      isOpen = _ref4.isOpen;
  return {
    color: 'inherit',
    '& .MuiInputBase-input': (_MuiInputBaseInpu = {
      padding: theme.spacing(1, 1, 1, 0),
      // vertical padding + font size from searchIcon
      paddingLeft: "calc(1em + " + theme.spacing(4) + ")",
      transition: theme.transitions.create('width'),
      width: '100%'
    }, _MuiInputBaseInpu[theme.breakpoints.up('sm')] = {
      width: isOpen ? '20ch' : '0ch',
      '&:focus': {
        width: '20ch'
      }
    }, _MuiInputBaseInpu)
  };
});
export default function (_ref5) {
  var onChange = _ref5.onChange,
      _ref5$initialValue = _ref5.initialValue,
      initialValue = _ref5$initialValue === void 0 ? '' : _ref5$initialValue,
      alwaysOpen = _ref5.alwaysOpen,
      _ref5$deferTime = _ref5.deferTime,
      deferTime = _ref5$deferTime === void 0 ? 1000 : _ref5$deferTime;

  var _useState = useState(''),
      value = _useState[0],
      setValue = _useState[1];

  useEffect(function () {
    setValue(initialValue); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var hasValue = value && value !== '';
  var isOpen = hasValue || alwaysOpen;

  var handleChange = function handleChange(v) {
    if (timeout) {
      clearTimeout(timeout);
    }

    setValue(v);
    timeout = setTimeout(function () {
      if (onChange) {
        onChange(v);
      }
    }, deferTime);
  };

  return /*#__PURE__*/React.createElement(Search, {
    isOpen: isOpen
  }, /*#__PURE__*/React.createElement(SearchIconWrapper, null, /*#__PURE__*/React.createElement(SearchIcon, null)), /*#__PURE__*/React.createElement(StyledInputBase, {
    isOpen: isOpen,
    autoComplete: "off",
    id: "search-input",
    value: value,
    ref: function ref(node) {
      if (node && initialValue && initialValue !== '') {
        node.focus();
      }
    },
    inputProps: {
      'aria-label': 'search'
    },
    onChange: function onChange(e) {
      return handleChange(e.target.value);
    }
  }));
}