import { Button, Paper, Typography } from '@mui/material';
import { Home } from '@mui/icons-material';
import Page from '../../containers/Page';
import React from 'react';
import { useIntl } from 'react-intl';

var PageNotFound = function PageNotFound() {
  var intl = useIntl();
  return /*#__PURE__*/React.createElement(Page, {
    pageTitle: intl.formatMessage({
      id: 'page_not_found'
    }) + ' MUI'
  }, /*#__PURE__*/React.createElement(Paper, {
    sx: {
      backgroundColor: function backgroundColor(t) {
        return t.palette.background.default;
      },
      margin: 0,
      height: "calc(100vh - 64px)"
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'center',
      justifyContent: 'center',
      height: "100%"
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "h4"
  }, "404"), /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle1"
  }, intl.formatMessage({
    id: 'page_not_found'
  }) + ' MUI'), /*#__PURE__*/React.createElement(Button, {
    color: "secondary",
    "aria-label": "home",
    href: "/",
    style: {
      marginTop: 20
    }
  }, /*#__PURE__*/React.createElement(Home, null)))));
};

export default PageNotFound;