"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Auth = require("base-shell/lib/providers/Auth");

var _Menu = require("../../providers/Menu");

var _Theme = require("../../providers/Theme");

var _material = require("@mui/material");

var _iconsMaterial = require("@mui/icons-material");

var _styles = require("@mui/material/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var MenuHeader = function MenuHeader() {
  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _useAppTheme = (0, _Theme.useTheme)(),
      toggleThisTheme = _useAppTheme.toggleThisTheme,
      isDarkMode = _useAppTheme.isDarkMode,
      isRTL = _useAppTheme.isRTL;

  var menuContext = (0, _Menu.useMenu)();
  var theme = (0, _styles.useTheme)();
  var authData = auth;

  var _ref = menuContext || {},
      toggleThis = _ref.toggleThis,
      isDesktop = _ref.isDesktop,
      isMiniMode = _ref.isMiniMode,
      isMenuOpen = _ref.isMenuOpen,
      isMiniSwitchVisibility = _ref.isMiniSwitchVisibility,
      isAuthMenuOpen = _ref.isAuthMenuOpen;

  var isAuthenticated = auth.isAuthenticated;

  var AvatarConstructor = function AvatarConstructor(_ref2) {
    var src = _ref2.src,
        alt = _ref2.alt,
        avatar = _ref2.avatar;
    return /*#__PURE__*/_react.default.createElement(_material.ListItemAvatar, {
      onClick: function onClick() {
        return toggleThis('isAuthMenuOpen');
      }
    }, /*#__PURE__*/_react.default.createElement(_material.Avatar, {
      src: src,
      alt: alt
    }, avatar));
  };

  var styles = {
    icon: {
      color: theme.palette.grey.A100,
      cursor: 'pointer'
    },
    toolbar: _extends({
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-end',
      padding: theme.spacing(1)
    }, theme.mixins.toolbar)
  };
  return /*#__PURE__*/_react.default.createElement(_material.Paper, {
    square: true,
    elevation: 3,
    sx: {
      backgroundColor: function backgroundColor(t) {
        return t.palette.mode === 'dark' ? t.palette.background.default : t.palette.primary.dark;
      },
      margin: 0,
      padding: 0
    }
  }, isMiniMode && isAuthenticated && /*#__PURE__*/_react.default.createElement("div", {
    style: _extends({}, styles.toolbar)
  }), /*#__PURE__*/_react.default.createElement(_material.List, {
    sx: _extends({}, !isAuthenticated ? styles.toolbar : {})
  }, !isMiniMode && /*#__PURE__*/_react.default.createElement(_material.ListItem, {
    sx: _extends({
      color: function color(t) {
        return theme.palette.grey.A100;
      },
      cursor: 'pointer'
    }, theme.mixins.toolbar)
  }, isAuthenticated && (authData.photoURL ? AvatarConstructor({
    src: authData.photoURL,
    alt: 'user'
  }) : AvatarConstructor({
    avatar: authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/_react.default.createElement(_iconsMaterial.Person, null)
  })), /*#__PURE__*/_react.default.createElement(_material.ListItemSecondaryAction, null, /*#__PURE__*/_react.default.createElement(_material.IconButton, {
    onClick: function onClick() {
      toggleThisTheme('isDarkMode');
    }
  }, isDarkMode ? /*#__PURE__*/_react.default.createElement(_iconsMaterial.BrightnessHigh, {
    sx: _extends({}, styles.icon)
  }) : /*#__PURE__*/_react.default.createElement(_iconsMaterial.Brightness4, {
    sx: _extends({}, styles.icon)
  })), isDesktop && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, isMiniSwitchVisibility && /*#__PURE__*/_react.default.createElement(_material.IconButton, {
    onClick: function onClick() {
      toggleThis('isMiniMode', true);
      toggleThis('isMenuOpen', false);
    }
  }, /*#__PURE__*/_react.default.createElement(_iconsMaterial.ChromeReaderMode, {
    sx: _extends({}, styles.icon)
  })), /*#__PURE__*/_react.default.createElement(_material.IconButton, {
    color: "inherit",
    onClick: function onClick() {
      toggleThis('isMenuOpen', false);
    }
  }, isRTL ? /*#__PURE__*/_react.default.createElement(_iconsMaterial.ChevronRight, {
    sx: _extends({}, styles.icon)
  }) : /*#__PURE__*/_react.default.createElement(_iconsMaterial.ChevronLeft, {
    sx: _extends({}, styles.icon)
  })), ' '))), isAuthenticated && /*#__PURE__*/_react.default.createElement(_material.ListItem, {
    onClick: function onClick() {
      toggleThis('isAuthMenuOpen');
    }
  }, !isMenuOpen && isMiniMode && isDesktop && (authData.photoURL ? AvatarConstructor({
    src: authData.photoURL,
    alt: 'user'
  }) : AvatarConstructor({
    avatar: authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/_react.default.createElement(_iconsMaterial.Person, null)
  })), !isMiniMode && /*#__PURE__*/_react.default.createElement(_material.ListItemText, {
    sx: {
      color: function color(t) {
        return theme.palette.grey.A100;
      },
      cursor: 'pointer',
      marginLeft: !isMenuOpen && isDesktop && authData.photoURL ? 7 : undefined,
      textOverflow: 'ellipsis'
    },
    secondaryTypographyProps: {
      color: function color(t) {
        return theme.palette.grey.A100;
      },
      width: 80,
      textOverflow: 'ellipsis'
    },
    primary: authData.displayName,
    secondary: authData.email
  }), isMenuOpen && /*#__PURE__*/_react.default.createElement(_material.ListItemSecondaryAction, {
    onClick: function onClick() {
      toggleThis('isAuthMenuOpen');
    }
  }, /*#__PURE__*/_react.default.createElement(_material.IconButton, null, isAuthMenuOpen ? /*#__PURE__*/_react.default.createElement(_iconsMaterial.ArrowDropUp, {
    sx: _extends({}, styles.icon)
  }) : /*#__PURE__*/_react.default.createElement(_iconsMaterial.ArrowDropDown, {
    sx: _extends({}, styles.icon)
  }))))));
};

var _default = MenuHeader;
exports.default = _default;
module.exports = exports.default;