"use strict";

exports.__esModule = true;
exports.default = _default;

var _react = _interopRequireWildcard(require("react"));

var _iconsMaterial = require("@mui/icons-material");

var _styles = require("@mui/material/styles");

var _material = require("@mui/material");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var timeout = null;
var Search = (0, _styles.styled)('div')(function (_ref) {
  var _ref2;

  var theme = _ref.theme,
      isOpen = _ref.isOpen;
  return _ref2 = {
    position: 'relative',
    borderRadius: theme.shape.borderRadius,
    backgroundColor: isOpen ? (0, _styles.alpha)(theme.palette.common.white, 0.15) : undefined,
    '&:hover': {
      backgroundColor: (0, _styles.alpha)(theme.palette.common.white, 0.25)
    },
    marginLeft: 0,
    width: '100%'
  }, _ref2[theme.breakpoints.up('sm')] = {
    marginLeft: theme.spacing(1),
    width: 'auto'
  }, _ref2;
});
var SearchIconWrapper = (0, _styles.styled)('div')(function (_ref3) {
  var theme = _ref3.theme;
  return {
    padding: theme.spacing(0, 2),
    height: '100%',
    position: 'absolute',
    pointerEvents: 'none',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center'
  };
});
var StyledInputBase = (0, _styles.styled)(_material.InputBase)(function (_ref4) {
  var _MuiInputBaseInpu;

  var theme = _ref4.theme,
      isOpen = _ref4.isOpen;
  return {
    color: 'inherit',
    '& .MuiInputBase-input': (_MuiInputBaseInpu = {
      padding: theme.spacing(1, 1, 1, 0),
      // vertical padding + font size from searchIcon
      paddingLeft: "calc(1em + " + theme.spacing(4) + ")",
      transition: theme.transitions.create('width'),
      width: '100%'
    }, _MuiInputBaseInpu[theme.breakpoints.up('sm')] = {
      width: isOpen ? '20ch' : '0ch',
      '&:focus': {
        width: '20ch'
      }
    }, _MuiInputBaseInpu)
  };
});

function _default(_ref5) {
  var onChange = _ref5.onChange,
      _ref5$initialValue = _ref5.initialValue,
      initialValue = _ref5$initialValue === void 0 ? '' : _ref5$initialValue,
      alwaysOpen = _ref5.alwaysOpen,
      _ref5$deferTime = _ref5.deferTime,
      deferTime = _ref5$deferTime === void 0 ? 1000 : _ref5$deferTime;

  var _useState = (0, _react.useState)(''),
      value = _useState[0],
      setValue = _useState[1];

  (0, _react.useEffect)(function () {
    setValue(initialValue); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var hasValue = value && value !== '';
  var isOpen = hasValue || alwaysOpen;

  var handleChange = function handleChange(v) {
    if (timeout) {
      clearTimeout(timeout);
    }

    setValue(v);
    timeout = setTimeout(function () {
      if (onChange) {
        onChange(v);
      }
    }, deferTime);
  };

  return /*#__PURE__*/_react.default.createElement(Search, {
    isOpen: isOpen
  }, /*#__PURE__*/_react.default.createElement(SearchIconWrapper, null, /*#__PURE__*/_react.default.createElement(_iconsMaterial.Search, null)), /*#__PURE__*/_react.default.createElement(StyledInputBase, {
    isOpen: isOpen,
    autoComplete: "off",
    id: "search-input",
    value: value,
    ref: function ref(node) {
      if (node && initialValue && initialValue !== '') {
        node.focus();
      }
    },
    inputProps: {
      'aria-label': 'search'
    },
    onChange: function onChange(e) {
      return handleChange(e.target.value);
    }
  }));
}

module.exports = exports.default;