"use strict";

exports.__esModule = true;
exports.default = _default;

var _react = _interopRequireWildcard(require("react"));

var _Theme = require("../../providers/Theme");

var _Context = _interopRequireDefault(require("../../providers/Menu/Context"));

var _styles = require("@mui/material/styles");

var _Config = require("base-shell/lib/providers/Config");

var _Online = require("base-shell/lib/providers/Online");

var _reactIntl = require("react-intl");

var _material = require("@mui/material");

var _iconsMaterial = require("@mui/icons-material");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default(_ref) {
  var children = _ref.children,
      pageTitle = _ref.pageTitle,
      onBackClick = _ref.onBackClick,
      isLoading = _ref.isLoading,
      _ref$appBarContent = _ref.appBarContent,
      appBarContent = _ref$appBarContent === void 0 ? null : _ref$appBarContent,
      contentStyle = _ref.contentStyle,
      _ref$tabs = _ref.tabs,
      tabs = _ref$tabs === void 0 ? null : _ref$tabs;

  var _useAppTheme = (0, _Theme.useTheme)(),
      isRTL = _useAppTheme.isRTL;

  var isOnline = (0, _Online.useOnline)();
  var theme = (0, _styles.useTheme)();

  var _useConfig = (0, _Config.useConfig)(),
      appConfig = _useConfig.appConfig;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      _ref3$width = _ref3.width,
      width = _ref3$width === void 0 ? 240 : _ref3$width,
      _ref3$appBarLeadingCo = _ref3.appBarLeadingContent,
      appBarLeadingContent = _ref3$appBarLeadingCo === void 0 ? null : _ref3$appBarLeadingCo;

  var _useContext = (0, _react.useContext)(_Context.default),
      toggleThis = _useContext.toggleThis,
      isDesktop = _useContext.isDesktop,
      isMenuOpen = _useContext.isMenuOpen;

  var intl = (0, _reactIntl.useIntl)();
  var headerTitle = '';

  if (typeof pageTitle === 'string' || pageTitle instanceof String) {
    headerTitle = pageTitle;
  }

  var handleDrawerMenuClick = function handleDrawerMenuClick() {
    if (!isMenuOpen) {
      toggleThis('isMiniMode', false);
      toggleThis('isMenuOpen', true);

      if (!isDesktop) {
        toggleThis('isMobileMenuOpen');
      }
    } else {
      toggleThis('isMobileMenuOpen');
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      width: '100%',
      display: 'flex',
      flexDirection: 'column',
      height: '100vh',
      overflow: 'hidden'
    }
  }, /*#__PURE__*/_react.default.createElement(_material.AppBar, {
    position: isDesktop ? 'absolute' : undefined,
    sx: {
      width: isMenuOpen && isDesktop ? "calc(100% - " + width + "px)" : undefined,
      zIndex: theme.zIndex['drawer'],
      transition: theme.transitions.create(['width', 'margin'], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      }),
      maxHeight: 64,
      marginLeft: isRTL ? 0 : -12,
      marginRight: isRTL ? 30 : 0
    }
  }, /*#__PURE__*/_react.default.createElement(_material.Toolbar, null, isMenuOpen && isDesktop || !onBackClick && /*#__PURE__*/_react.default.createElement(_material.IconButton, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: handleDrawerMenuClick,
    edge: "start"
  }, /*#__PURE__*/_react.default.createElement(_iconsMaterial.Menu, null)), onBackClick && /*#__PURE__*/_react.default.createElement(_material.IconButton, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: onBackClick
  }, /*#__PURE__*/_react.default.createElement(_iconsMaterial.ChevronLeft, null)), !onBackClick && isMenuOpen && false && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      marginRight: 32
    }
  }), appBarLeadingContent, /*#__PURE__*/_react.default.createElement(_material.Typography, {
    variant: "h6",
    color: "inherit",
    noWrap: true
  }, headerTitle), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      flex: '1 1 auto'
    }
  }), appBarContent)), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      alignItems: 'center',
      justifyContent: 'flex-end',
      //...theme.mixins.toolbar,
      minHeight: 64 //height of AppBar

    }
  }), isLoading && /*#__PURE__*/_react.default.createElement(_material.LinearProgress, null), !isOnline && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      width: '100%',
      height: 15,
      backgroundColor: theme.palette.secondary.main
    }
  }, /*#__PURE__*/_react.default.createElement(_material.Typography, {
    variant: "caption",
    color: "textSecondary",
    noWrap: true
  }, intl.formatMessage({
    id: 'offline',
    defaultMessage: 'Offline'
  }))), tabs, /*#__PURE__*/_react.default.createElement("div", {
    style: _extends({
      flex: 1,
      overflow: 'auto'
    }, contentStyle)
  }, children));
}

module.exports = exports.default;