"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Context = _interopRequireDefault(require("./Context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Provider = function Provider(_ref) {
  var children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'theme' : _ref$persistKey,
      appConfig = _ref.appConfig;

  var _ref2 = appConfig || {},
      themeConfig = _ref2.theme;

  var _ref3 = themeConfig || {},
      defaultThemeID = _ref3.defaultThemeID,
      defaultIsDarkMode = _ref3.defaultIsDarkMode,
      defaultIsRTL = _ref3.defaultIsRTL;

  var _useState = (0, _react.useState)(defaultThemeID),
      themeID = _useState[0],
      setThemeID = _useState[1];

  var _useState2 = (0, _react.useState)(defaultIsDarkMode),
      isDarkMode = _useState2[0],
      setIsDarkMode = _useState2[1];

  var _useState3 = (0, _react.useState)(defaultIsRTL),
      isRTL = _useState3[0],
      setIsRTL = _useState3[1];

  var themeIDKey = persistKey + ":themeID";
  var isDarkModeKey = persistKey + ":isDarkMode";
  var isRTLKey = persistKey + ":isRTL";

  var toggleThisTheme = function toggleThisTheme(mode) {
    if (mode === 'isRTL') setIsRTL(!isRTL);
    if (mode === 'isDarkMode') setIsDarkMode(!isDarkMode);
  };

  (0, _react.useEffect)(function () {
    var persistThemeID = localStorage.getItem(themeIDKey);
    var persistIsDarkMode = localStorage.getItem(isDarkModeKey);
    var persistIsRTL = localStorage.getItem(isRTLKey);

    if (persistThemeID) {
      setThemeID(persistThemeID);
    }

    if (persistIsDarkMode) {
      // convert to boolean
      setIsDarkMode(persistIsDarkMode === 'true');
    }

    if (persistIsRTL) {
      //have to convert the stored string back to boolean
      setIsRTL(persistIsRTL === 'true' ? true : false);
    }
  }, [themeIDKey, isDarkModeKey, isRTLKey]);
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(themeIDKey, themeID);
    } catch (error) {
      console.warn(error);
    }
  }, [themeID, themeIDKey]);
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(isDarkModeKey, isDarkMode);
    } catch (error) {
      console.warn(error);
    }
  }, [isDarkMode, isDarkModeKey]);
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(isRTLKey, isRTL);
    } catch (error) {
      console.warn(error);
    }
  }, [isRTL, isRTLKey]);
  return /*#__PURE__*/_react.default.createElement(_Context.default.Provider, {
    value: {
      themeID: themeID,
      setThemeID: setThemeID,
      isDarkMode: isDarkMode,
      isRTL: isRTL,
      toggleThisTheme: toggleThisTheme
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      direction: isRTL ? 'rtl' : 'ltr'
    }
  }, children));
};

var _default = Provider;
exports.default = _default;
module.exports = exports.default;